# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2018-09-28.      #
#                                                           #
# Ruby Bindings Version 2.1.18                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Controls remote mains switches
  class BrickletRemoteSwitch < Device
    DEVICE_IDENTIFIER = 235 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Remote Switch Bricklet' # :nodoc:

    # This callback is triggered whenever the switching state changes
    # from busy to ready, see BrickletRemoteSwitch#get_switching_state.
    CALLBACK_SWITCHING_DONE = 3

    FUNCTION_SWITCH_SOCKET = 1 # :nodoc:
    FUNCTION_GET_SWITCHING_STATE = 2 # :nodoc:
    FUNCTION_SET_REPEATS = 4 # :nodoc:
    FUNCTION_GET_REPEATS = 5 # :nodoc:
    FUNCTION_SWITCH_SOCKET_A = 6 # :nodoc:
    FUNCTION_SWITCH_SOCKET_B = 7 # :nodoc:
    FUNCTION_DIM_SOCKET_B = 8 # :nodoc:
    FUNCTION_SWITCH_SOCKET_C = 9 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    SWITCH_TO_OFF = 0 # :nodoc:
    SWITCH_TO_ON = 1 # :nodoc:
    SWITCHING_STATE_READY = 0 # :nodoc:
    SWITCHING_STATE_BUSY = 1 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_SWITCH_SOCKET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SWITCHING_STATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_REPEATS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_REPEATS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SWITCH_SOCKET_A] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SWITCH_SOCKET_B] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DIM_SOCKET_B] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SWITCH_SOCKET_C] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_SWITCHING_DONE] = ''

    end

    # This function is deprecated, use BrickletRemoteSwitch#switch_socket_a instead.
    def switch_socket(house_code, receiver_code, switch_to)
      send_request FUNCTION_SWITCH_SOCKET, [house_code, receiver_code, switch_to], 'C C C', 0, ''
    end

    # Returns the current switching state. If the current state is busy, the
    # Bricklet is currently sending a code to switch a socket. It will not
    # accept any calls of BrickletRemoteSwitch#switch_socket until the state changes to ready.
    # 
    # How long the switching takes is dependent on the number of repeats, see
    # BrickletRemoteSwitch#set_repeats.
    def get_switching_state
      send_request FUNCTION_GET_SWITCHING_STATE, [], '', 1, 'C'
    end

    # Sets the number of times the code is send when of the BrickletRemoteSwitch#switch_socket
    # functions is called. The repeats basically correspond to the amount of time
    # that a button of the remote is pressed.
    # 
    # Some dimmers are controlled by the length of a button pressed,
    # this can be simulated by increasing the repeats.
    # 
    # The default value is 5.
    def set_repeats(repeats)
      send_request FUNCTION_SET_REPEATS, [repeats], 'C', 0, ''
    end

    # Returns the number of repeats as set by BrickletRemoteSwitch#set_repeats.
    def get_repeats
      send_request FUNCTION_GET_REPEATS, [], '', 1, 'C'
    end

    # To switch a type A socket you have to give the house code, receiver code and the
    # state (on or off) you want to switch to.
    # 
    # The house code and receiver code have a range of 0 to 31 (5bit).
    # 
    # A detailed description on how you can figure out the house and receiver code
    # can be found :ref:`here <remote_switch_bricklet_type_a_house_and_receiver_code>`.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def switch_socket_a(house_code, receiver_code, switch_to)
      send_request FUNCTION_SWITCH_SOCKET_A, [house_code, receiver_code, switch_to], 'C C C', 0, ''
    end

    # To switch a type B socket you have to give the address, unit and the state
    # (on or off) you want to switch to.
    # 
    # The address has a range of 0 to 67108863 (26bit) and the unit has a range
    # of 0 to 15 (4bit). To switch all devices with the same address use 255 for
    # the unit.
    # 
    # A detailed description on how you can teach a socket the address and unit can
    # be found :ref:`here <remote_switch_bricklet_type_b_address_and_unit>`.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def switch_socket_b(address, unit, switch_to)
      send_request FUNCTION_SWITCH_SOCKET_B, [address, unit, switch_to], 'L C C', 0, ''
    end

    # To control a type B dimmer you have to give the address, unit and the
    # dim value you want to set the dimmer to.
    # 
    # The address has a range of 0 to 67108863 (26bit), the unit and the dim value
    # has a range of 0 to 15 (4bit).
    # 
    # A detailed description on how you can teach a dimmer the address and unit can
    # be found :ref:`here <remote_switch_bricklet_type_b_address_and_unit>`.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def dim_socket_b(address, unit, dim_value)
      send_request FUNCTION_DIM_SOCKET_B, [address, unit, dim_value], 'L C C', 0, ''
    end

    # To switch a type C socket you have to give the system code, device code and the
    # state (on or off) you want to switch to.
    # 
    # The system code has a range of 'A' to 'P' (4bit) and the device code has a
    # range of 1 to 16 (4bit).
    # 
    # A detailed description on how you can figure out the system and device code
    # can be found :ref:`here <remote_switch_bricklet_type_c_system_and_device_code>`.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def switch_socket_c(system_code, device_code, switch_to)
      send_request FUNCTION_SWITCH_SOCKET_C, [system_code, device_code, switch_to], 'k C C', 0, ''
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
