# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2018-09-28.      #
#                                                           #
# Ruby Bindings Version 2.1.18                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Communicates with RS232 devices
  class BrickletRS232V2 < Device
    DEVICE_IDENTIFIER = 2108 # :nodoc:
    DEVICE_DISPLAY_NAME = 'RS232 Bricklet 2.0' # :nodoc:

    # This callback is called if new data is available.
    # 
    # To enable this callback, use BrickletRS232V2#enable_read_callback.
    CALLBACK_READ_LOW_LEVEL = 12

    # This callback is called if a new error occurs. It returns
    # the current overrun and parity error count.
    CALLBACK_ERROR_COUNT = 13

    # This callback is called if new data is available.
    # 
    # To enable this callback, use BrickletRS232V2#enable_read_callback.
    CALLBACK_READ = -12

    FUNCTION_WRITE_LOW_LEVEL = 1 # :nodoc:
    FUNCTION_READ_LOW_LEVEL = 2 # :nodoc:
    FUNCTION_ENABLE_READ_CALLBACK = 3 # :nodoc:
    FUNCTION_DISABLE_READ_CALLBACK = 4 # :nodoc:
    FUNCTION_IS_READ_CALLBACK_ENABLED = 5 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_BUFFER_CONFIG = 8 # :nodoc:
    FUNCTION_GET_BUFFER_CONFIG = 9 # :nodoc:
    FUNCTION_GET_BUFFER_STATUS = 10 # :nodoc:
    FUNCTION_GET_ERROR_COUNT = 11 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    PARITY_NONE = 0 # :nodoc:
    PARITY_ODD = 1 # :nodoc:
    PARITY_EVEN = 2 # :nodoc:
    STOPBITS_1 = 1 # :nodoc:
    STOPBITS_2 = 2 # :nodoc:
    WORDLENGTH_5 = 5 # :nodoc:
    WORDLENGTH_6 = 6 # :nodoc:
    WORDLENGTH_7 = 7 # :nodoc:
    WORDLENGTH_8 = 8 # :nodoc:
    FLOWCONTROL_OFF = 0 # :nodoc:
    FLOWCONTROL_SOFTWARE = 1 # :nodoc:
    FLOWCONTROL_HARDWARE = 2 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_WRITE_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_READ_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_READ_CALLBACK] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_DISABLE_READ_CALLBACK] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_IS_READ_CALLBACK_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BUFFER_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_BUFFER_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BUFFER_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_READ_LOW_LEVEL] = 'S S k60'
      @callback_formats[CALLBACK_ERROR_COUNT] = 'L L'

      @high_level_callbacks[CALLBACK_READ] = [['stream_length', 'stream_chunk_offset', 'stream_chunk_data'], {'fixed_length' => nil, 'single_chunk' => false}, nil]
    end

    # Writes characters to the RS232 interface. The characters can be binary data,
    # ASCII or similar is not necessary.
    # 
    # The return value is the number of characters that were written.
    # 
    # See BrickletRS232V2#set_configuration for configuration possibilities
    # regarding baud rate, parity and so on.
    def write_low_level(message_length, message_chunk_offset, message_chunk_data)
      send_request FUNCTION_WRITE_LOW_LEVEL, [message_length, message_chunk_offset, message_chunk_data], 'S S k60', 1, 'C'
    end

    # Returns up to *length* characters from receive buffer.
    # 
    # Instead of polling with this function, you can also use
    # callbacks. But note that this function will return available
    # data only when the read callback is disabled.
    # See BrickletRS232V2#enable_read_callback and CALLBACK_READ callback.
    def read_low_level(length)
      send_request FUNCTION_READ_LOW_LEVEL, [length], 'S', 64, 'S S k60'
    end

    # Enables the CALLBACK_READ callback.
    # 
    # By default the callback is disabled.
    def enable_read_callback
      send_request FUNCTION_ENABLE_READ_CALLBACK, [], '', 0, ''
    end

    # Disables the CALLBACK_READ callback.
    # 
    # By default the callback is disabled.
    def disable_read_callback
      send_request FUNCTION_DISABLE_READ_CALLBACK, [], '', 0, ''
    end

    # Returns *true* if the CALLBACK_READ callback is enabled,
    # *false* otherwise.
    def is_read_callback_enabled
      send_request FUNCTION_IS_READ_CALLBACK_ENABLED, [], '', 1, '?'
    end

    # Sets the configuration for the RS232 communication. Available options:
    # 
    # * Baud rate between 100 and 2000000 baud.
    # * Parity of none, odd or even.
    # * Stop bits can be 1 or 2.
    # * Word length of 5 to 8.
    # * Flow control can be off, software or hardware.
    # 
    # The default is: 115200 baud, parity none, 1 stop bit, word length 8.
    def set_configuration(baudrate, parity, stopbits, wordlength, flowcontrol)
      send_request FUNCTION_SET_CONFIGURATION, [baudrate, parity, stopbits, wordlength, flowcontrol], 'L C C C C', 0, ''
    end

    # Returns the configuration as set by BrickletRS232V2#set_configuration.
    def get_configuration
      send_request FUNCTION_GET_CONFIGURATION, [], '', 8, 'L C C C C'
    end

    # Sets the send and receive buffer size in byte. In sum there is
    # 10240 byte (10kb) buffer available and the minimum buffer size
    # is 1024 byte (1kb) for both.
    # 
    # The current buffer content is lost if this function is called.
    # 
    # The send buffer holds data that is given by BrickletRS232V2#write and
    # can not be written yet. The receive buffer holds data that is
    # received through RS232 but could not yet be send to the
    # user, either by BrickletRS232V2#read or through CALLBACK_READ callback.
    # 
    # The default configuration is 5120 byte (5kb) per buffer.
    def set_buffer_config(send_buffer_size, receive_buffer_size)
      send_request FUNCTION_SET_BUFFER_CONFIG, [send_buffer_size, receive_buffer_size], 'S S', 0, ''
    end

    # Returns the buffer configuration as set by BrickletRS232V2#set_buffer_config.
    def get_buffer_config
      send_request FUNCTION_GET_BUFFER_CONFIG, [], '', 4, 'S S'
    end

    # Returns the currently used bytes for the send and received buffer.
    # 
    # See BrickletRS232V2#set_buffer_config for buffer size configuration.
    def get_buffer_status
      send_request FUNCTION_GET_BUFFER_STATUS, [], '', 4, 'S S'
    end

    # Returns the current number of overrun and parity errors.
    def get_error_count
      send_request FUNCTION_GET_ERROR_COUNT, [], '', 8, 'L L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 16, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 1, 'C'
    end

    # Returns the current bootloader mode, see BrickletRS232V2#set_bootloader_mode.
    def get_bootloader_mode
      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 1, 'C'
    end

    # Sets the firmware pointer for BrickletRS232V2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 0, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletRS232V2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 1, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 0, ''
    end

    # Returns the configuration as set by BrickletRS232V2#set_status_led_config
    def get_status_led_config
      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 1, 'C'
    end

    # Returns the temperature in °C as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 2, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      send_request FUNCTION_RESET, [], '', 0, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      send_request FUNCTION_WRITE_UID, [uid], 'L', 0, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      send_request FUNCTION_READ_UID, [], '', 4, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

    # Writes characters to the RS232 interface. The characters can be binary data,
    # ASCII or similar is not necessary.
    # 
    # The return value is the number of characters that were written.
    # 
    # See BrickletRS232V2#set_configuration for configuration possibilities
    # regarding baud rate, parity and so on.
    def write(message)
      if message.length > 65535
        raise ArgumentError, 'Message can be at most 65535 items long'
      end

      message_length = message.length
      message_chunk_offset = 0

      if message_length == 0
        message_chunk_data = ['\0'] * 60
        ret = write_low_level message_length, message_chunk_offset, message_chunk_data
        message_written = ret
      else
        message_written = 0 # assigned in block

        @stream_mutex.synchronize {
          while message_chunk_offset < message_length
            message_chunk_data = message[message_chunk_offset, 60]

            if message_chunk_data.length < 60
              message_chunk_data += ['\0'] * (60 - message_chunk_data.length)
            end

            ret = write_low_level message_length, message_chunk_offset, message_chunk_data
            message_written += ret

            if ret < 60
              break # either last chunk or short write
            end

            message_chunk_offset += 60
          end
        }
      end

      message_written
    end

    # Returns up to *length* characters from receive buffer.
    # 
    # Instead of polling with this function, you can also use
    # callbacks. But note that this function will return available
    # data only when the read callback is disabled.
    # See BrickletRS232V2#enable_read_callback and CALLBACK_READ callback.
    def read(length)
      message_length = nil # assigned in block
      message_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = read_low_level length
        message_length = ret[0]
        message_chunk_offset = ret[1]
        message_out_of_sync = message_chunk_offset != 0
        message_data = ret[2]

        while not message_out_of_sync and message_data.length < message_length
          ret = read_low_level length
          message_length = ret[0]
          message_chunk_offset = ret[1]
          message_out_of_sync = message_chunk_offset != message_data.length
          message_data += ret[2]
        end

        if message_out_of_sync # discard remaining stream to bring it back in-sync
          while message_chunk_offset + 60 < message_length
            ret = read_low_level length
            message_length = ret[0]
            message_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Message stream is out-of-sync'
        end
      }

      message_data[0, message_length]
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
